//
//  Project   : Navier-Stokes
//  File      : stokesConv.cc
//  Author    : Ronald Kriemann
//  Purpose   : test of 3D grids
//
// arch-tag: f477d4e8-965d-4d72-9d65-cb7a455144ca
//

#include "misc/memory.hh"

#include "net/net.hh"

#include "visual/drawapp.hh"
#include "visual/TPOVRay.hh"

//
// mainfunction
//
int
main( int argc, char **argv ) 
{
    TNet<2>  *net2D = new TNet<2>( "grids/start1.tri" );
    TNet<3>  *net3D = new TNet<3>( "grids/cube.tri" ), *fnet, *ffnet;
    TDrawApp *app = new TDrawApp;

    app->draw( *net2D, "psfiles/net.ps" );
    app->drawNet( net3D, "psfiles/cube.pov", POVRAY );
    app->drawNet( net3D, "psfiles/cube.wrl", VRML );

    fnet = net3D->refine();
    app->drawNet( fnet, "psfiles/fcube.pov", POVRAY );
    app->drawNet( fnet, "psfiles/fcube.wrl", VRML );
    
    ffnet = fnet->refine();
    app->drawNet( ffnet, "psfiles/ffcube.pov", POVRAY );
    app->drawNet( ffnet, "psfiles/ffcube.wrl", VRML );
    
    if (net2D->delRef()) delete net2D;
    if (net3D->delRef()) delete net3D;
    delete fnet;
    delete ffnet;
    delete app;

    TMemory::statistics();
}
