//
//  Project     : libgraph
//  File        : T2DPlanarNode.cc
//  Author      : Ronald Kriemann
//  Purpose     : class for a node in a planar graph in 2D
//
// arch-tag: dd50ded1-f97a-4c78-86d6-5bc753485193
//

#include "T2DPlanarNode.hh"

/////////////////////////////////////////////////
//
// constructor and destructor
//
    
T2DPlanarNode::T2DPlanarNode ( TMarkableNode & node,
                               TPlanarCycle * pMinCyc, 
                               TPlanarCycle * pMaxCyc, 
                               TFloat w )
        : TPlanarNode( node, pMinCyc, pMaxCyc, w )
{
    pVector = NULL;
}

T2DPlanarNode::T2DPlanarNode ( uint n, int m,
                               TVector<2> * pVec,
                               TPlanarCycle * pMinCyc, 
                               TPlanarCycle * pMaxCyc, 
                               TFloat w )
        : TPlanarNode( n, m, pMinCyc, pMaxCyc, w )
{
    pVector = pVec;
}

T2DPlanarNode::~T2DPlanarNode ()
{
}

/////////////////////////////////////////////////
//
// access member variables
//
    
TVector<2> *
T2DPlanarNode::vector ()
{
    return pVector;
}

void
T2DPlanarNode::setVector ( TVector<2> * pVec )
{
    pVector = pVec;
}

/////////////////////////////////////////////////
//
// virtual constructors
//
    
T2DPlanarNode *
T2DPlanarNode::clone ()
{
    return new T2DPlanarNode( name, _mark,
                              pVector,
                              pMinCycle, pMaxCycle,
                              _weight );
}

T2DPlanarNode *
T2DPlanarNode::create ( uint n )
{
    return new T2DPlanarNode( n );
}
