//
//  Project     : libgraph
//  File        : T3DMarkableNode.cc
//  Author      : Ronald Kriemann
//  Purpose     : class for a markable node in R^3
//
// arch-tag: 731f3bd7-1cfa-4df6-8600-39d79c3076ec
//

#include "T3DMarkableNode.hh"

///////////////////////////////////////////
//
// constructor and destructor
//

T3DMarkableNode::T3DMarkableNode ( uint name )
        : TMarkableNode( name )
{
    pVector = NULL;
}

T3DMarkableNode::T3DMarkableNode ( uint name, TVector<3> * pVec )
        : TMarkableNode( name )
{
    pVector = pVec;
}

T3DMarkableNode::T3DMarkableNode ( uint name, uint mark, TVector<3> * pVec )
        : TMarkableNode( name, mark )
{
    pVector = pVec;
}

T3DMarkableNode::~T3DMarkableNode ()
{
}

///////////////////////////////////////////
//
// access member variables
//

TVector<3> *
T3DMarkableNode::vector () const
{
    return pVector;
}

/////////////////////////////////////////////////
//
// virtual constructors
//

T3DMarkableNode *
T3DMarkableNode::clone ()
{
    return new T3DMarkableNode( name, _mark, pVector );
}

T3DMarkableNode *
T3DMarkableNode::create ( uint n )
{
    return new T3DMarkableNode( n );
}
