//
//  Project     : libgraph
//  File        : TFSNode.hh
//  Author      : Ronald Kriemann
//  Purpose     : class representing a flowsurface in a graph
//
// arch-tag: aef68c6b-123a-4c9f-9a4e-811984246117
//

#include "T3DCellEdgeGraph.hh"

#include "TFSNode.hh"

/////////////////////////////////////////////
//
// constructor and destructor
//

TFSNode::TFSNode ( uint name, T3DCellEdgeGraph * pFS )
        : TMarkableNode( name )
{
    pFlowSurface = pFS;
}

TFSNode::~TFSNode ()
{
}

/////////////////////////////////////////////
//
// access member variables
//

T3DCellEdgeGraph *
TFSNode::flowSurface () const
{
    return pFlowSurface;
}
