//
//  Project     : libgraph
//  File        : T2DPlanarNode.hh
//  Author      : Ronald Kriemann
//  Purpose     : class for a node in a planar graph in 2D
//
// arch-tag: c6f38a4a-27ea-4e0b-aac8-d705ae0e7f1f
//

#ifndef __T2DPLANARNODE_HH
#define __T2DPLANARNODE_HH

#include "vector.hh"

#include "TPlanarNode.hh"

//
//
//
class T2DPlanarNode : public TPlanarNode
{
protected:
    // vector assoc. with the node
    TVector<2>  * pVector;

public:
    /////////////////////////////////////////////////
    //
	// constructor and destructor
    //
    
	T2DPlanarNode ( TMarkableNode & node,
                    TPlanarCycle * pMinCyc = NULL, 
                    TPlanarCycle * pMaxCyc = NULL, 
                    TFloat w = 0.0 );
	T2DPlanarNode ( uint n, int m = NO_MARK,
                    TVector<2> * pVec = NULL,
                    TPlanarCycle * pMinCyc = NULL, 
                    TPlanarCycle * pMaxCyc = NULL, 
                    TFloat w = 0.0 );

	virtual ~T2DPlanarNode ();

    /////////////////////////////////////////////////
    //
    // access member variables
    //
    
	virtual TVector<2> * vector ();
	virtual void setVector ( TVector<2> * pVec );

    /////////////////////////////////////////////////
    //
    // virtual constructors
    //
    
	virtual T2DPlanarNode * clone ();
	virtual T2DPlanarNode * create ( uint n );
};

#endif  // __T2DPLANARNODE_HH
