//
//  Project     : libgraph
//  File        : T3DMarkableNode.hh
//  Author      : Ronald Kriemann
//  Purpose     : class for a markable node in R^3
//
// arch-tag: 74021ae1-6241-40c2-b772-6b066bccc29b
//

#ifndef __T3DMARKABLENODE_HH
#define __T3DMARKABLENODE_HH

#include "vector.hh"

#include "nodes.hh"

//
// this class represents a markable node with a vector in R^3
//
class T3DMarkableNode : public TMarkableNode
{
protected:
    // the vector to store
    TVector<3>  * pVector;

public:
    ///////////////////////////////////////////
    //
    // constructor and destructor
    //

    T3DMarkableNode ( uint name );
    T3DMarkableNode ( uint name, TVector<3> * pVec );
    T3DMarkableNode ( uint name, uint mark, TVector<3> * pVec );

    virtual ~T3DMarkableNode ();

    ///////////////////////////////////////////
    //
    // access member variables
    //

    virtual TVector<3> * vector () const;

    /////////////////////////////////////////////////
    //
    // virtual constructors
    //
    
	virtual T3DMarkableNode * clone ();
	virtual T3DMarkableNode * create ( uint n );
};

#endif  // __T3DMARKABLENODE_HH
