//
//  Project     : libgraph
//  File        : T3DVertexData.hh
//  Author      : Ronald Kriemann
//  Purpose     : class for put add. data to net-nodes (vector)
//                (needed for flow surfaces)
//
// arch-tag: e791f6bb-de3c-4568-bc55-dead1c38cdfc
//

#ifndef __T3DVERTEXDATA_HH
#define __T3DVERTEXDATA_HH

#include "multiref.hh"

// forward decl
template <int N> class TVertex;
class TNode;
class T3DCellEdgeGraph;

//
//
//
class T3DVertexData : public TMultiReference
{
protected:
    // the node to enhance
    TVertex<3>       * pNode;
    
    // indicate whether vertex is in a flow surface
    T3DCellEdgeGraph * pFlowSurface;

    // pointer to node in surface graph
    TNode            * pSurfaceNode;
    
public:
    ////////////////////////////////////////////
    //
    // constructors and destructors
    //
    T3DVertexData ( TVertex<3> * v );

    virtual ~T3DVertexData ();

    ////////////////////////////////////////////
    //
    // access member variables
    //

    virtual const bool inSurface () const;
//    virtual void setInSurface ( bool b );

    virtual TVertex<3> * node () const;

    virtual TNode * surfaceNode () const;
    virtual void setSurfaceNode ( TNode * pSNode );

    virtual T3DCellEdgeGraph * flowSurface () const;
    virtual void setFlowSurface ( T3DCellEdgeGraph * pFS );
};

#endif  // __T3DVERTEXDATA_HH
