//
//  Project     : libgraph
//  File        : TCoarsener.hh
//  Author      : Thomas Probst
//  Purpose     : define coarse grid
//
// arch-tag: f07b9f9c-e068-4b9c-8b84-2c7c03804961
//

#ifndef __TCOARSENER_HH
#define __TCOARSENER_HH

#include "memory.hh"
#include "dynarray.hh"

#include "TPermutation.hh"
//#include "cyclicRedMatrixblock.hh"

#define SEMI 1
#define FULL 2

//
//
//
class TCoarsener : public TMemory
{
protected:
    // values for graph definition
    TFloat  xi;
    uint    criterion;
    
    uint    strategy;

public:
    ///////////////////////////////////////////
    //
	// constructor and destructor
    //
    
	TCoarsener ( TFloat xi, uint criterion, uint strategy = SEMI );

    ~TCoarsener();

    ///////////////////////////////////////////
    //
    // access member variables
    //
    
    const uint getStrategy () const;
    void setStrategy ( uint strategy );

    ///////////////////////////////////////////
    //
    // do the coarsening
    //
    
	TPermutation * coarse ( TMatrixBlock  * pMatrix,
                            uint         & noOfReds);
};

#endif  // __TCOARSENER_HH
