//
//  Project   : libnet
//  File      : TConvDiffHierarchy.hh
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : class to build a matrix and prolongation hierarchy for
//              the convection-diffusion equation
//
// arch-tag: 56363329-d3e2-4ec9-b8bc-f57db47090e3
//

#ifndef __TCONVDIFFHIERARCHY_HH
#define __TCONVDIFFHIERARCHY_HH

//
// class to build a matrix and prolongation hierarchy for
// the convection-diffusion equation
//

#include "TBasisHierarchy.hh"
#include "TConvDiffFE.hh"
#include "TConvDiffDoFManager.hh"

template<int N>
class TConvDiffHierarchy : TBasisHierarchy<N> 
{
public:
    // constructor
    TConvDiffHierarchy () {};
    // destructor
    virtual ~TConvDiffHierarchy () { };

    virtual void buildHierarchy ( TBasisDoFManager<N> *DoFManager,
                          TBasisEqn<N> *eqn,
                          TBasisFE<N> *fe,
                          TNetHierarchy<N> *netHier, 
                          TBlockMatrix **pMatrix, 
                          TBlockVector<TFloat> **pRHS, 
                          TBlockVector<TFloat> **pX );
};

#endif  // __TCONVDIFFHIERARCHY
