//
//  Project   : libmisc
//  File      : TConvEqn.hh
//  Author    : Ronald Kriemann
//  Purpose   : baseclass for all convection-related equations
//
// arch-tag: 89039e06-54a0-44c7-b5aa-95a96765f38d
//

#ifndef __TCONVEQN_HH
#define __TCONVEQN_HH

#include "vector.hh"

#include "TBasisEqn.hh"

//
// baseclass for all convection-related equations
// (only purpose is to declare a evalConv-method)
//
template <int N>
class TConvEqn : public TBasisEqn<N>
{
public:
    ///////////////////////////////////////////////////
    //
    // constructor and destructor
    //

    TConvEqn ();

    virtual ~TConvEqn ();

    ///////////////////////////////////////////////////
    //
    // methods to evaluate equation
    //

    virtual void evalConv ( TVector<N> * v, TVector<N> * b ) const = 0;
};

#endif  // __TCONVEQN_HH
