//
//  Project :  libvisual
//  File    :  TConvView.hh
//  Purpose :  class for convergence visualization
//  Author  :  Ronald Kriemann
//
// arch-tag: 74449da2-ea2d-4b04-8222-f8eb6148b974
//

#ifndef __TCONVVIEW_HH
#define __TCONVVIEW_HH

#include "defines.hh"
#include "dynarray.hh"

#include "view.hh"

//
// this class draws a simple graphic of the 
// given convergence rates
//
class TConvView : public TView
{
protected:
	// the convergence rates
	TDynArray<TFloat>  arrConv;

public:
	// constructor
	TConvView ( TDynArray<TFloat> *parrConv );

	// draw the net
	virtual void draw ( TPrinter& p );
};

#endif  // __TCONVVIEW_HH
