//
//  Project    : libnet
//  File       : TDoFDesc.hh
//  Author     : Ronald Kriemann 
//  Purpose    : class for holding dof names
//
// arch-tag: e44e11f2-903d-4859-a3c1-f83137ee97f7
//

#ifndef __TDOFDESC_HH
#define __TDOFDESC_HH

#include "memory.hh"

// default for nothing
#define NO_DOF      -1

// default for nothing
#define NOT_DEFINED -2

//
//
//
class TDoFDesc : public TMemory
{
protected:
    // hold the names
    long  *arrNames;

    // no of names
    int    noOfNames;
    
public:
    // constructor
    TDoFDesc ( int m );

    // destructor
    ~TDoFDesc ();

    // access names
    long getName ( int i ) const;
    void setName ( int i, int name );
    int getNoOfNames ( ) { return (noOfNames) ;}
};

#endif  // __TDOFDESC_HH
