//
//  Project     : libgraph
//  File        : TMatrixGraph.hh
//  Author      : Ronald Kriemann
//  Purpose     : class to build graph of a matrix
//
// arch-tag: 743c8979-5bee-4a7f-a646-ce404ff658d6
//

#ifndef __TMATRIXGRAPH_HH
#define __TMATRIXGRAPH_HH

#include "defines.hh"

#include "matrixblock.hh"

#include "basegraph.hh"
#include "basenode.hh"

//
//
//
class TMatrixGraph : public TGraph
{
protected:
    // matrix represented by graph
    TMatrixBlock  * pMatrix;
    
    // variables for edge-definition
    uint            criterion;
    TFloat          xi;

public:
    ////////////////////////////////////////
    //
    // constructor and destructor
    //

    TMatrixGraph ( TMatrixBlock * pMatrix,
                   uint           criterion,
                   TFloat         xi );

    virtual ~TMatrixGraph ();

protected:
    ////////////////////////////////////////
    //
    // encapsulation of graph creation
    //

    // actually build graph
    virtual void buildGraph ();

    // decide whether an edge is strong or not
    virtual const bool isStrong ( TNode * pNode0,
                                  TNode * pNode1 ) const;
};

#endif  // __TMATRIXGRAPH_HH
