#ifndef __TSTOKESBOUNDARYDESC_HH
#define __TSTOKESBOUNDARYDESC_HH
//
//  Project   : libnet
//  File      : TStokesBoundaryDesc.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: d39138a6-227e-4b09-b6ce-37896d0fdddc
//

#include "memory.hh"
#include "dynarray.hh"
#include "multiref.hh"
#include "TFunction.hh"
#include "TBoundaryDesc.hh"

// default type
#define NO_TYPE  -1

//
//
//
template <int N>
class TStokesBoundaryDesc : public TBoundaryDesc
{
protected:
    // functions on boundary: Neumann or Dirichlet
    TDynArray<TFunction< N > * > arrFunc;

public:
    // constructor
    TStokesBoundaryDesc ( int n = 0 );

    // destructor
    ~TStokesBoundaryDesc ();

   // initialisation
    void setNoOfTypes ( uint n );

    // access functions
    TFunction< N >*  getFunc ( uint i ) const;
    void setFunc ( uint i, TFunction< N >*  af);
};

#endif  // __TSTOKESBOUNDARYDESC_HH
