//
//  Project   : libnet
//  File      : cgSolver.hh
//  Author    : Sabine Gutsch / Thomas Probst
//  Purpose   : cg solver
//
// arch-tag: d71981ae-cc2f-43b5-aa48-3b1670b22cc4
//

#ifndef __CGSOLVER_HH
#define __CGSOLVER_HH

#include "TPrecSolver.hh"

//
// class for the cgsolver
//
class TCGSolver : public TPrecSolver
{
protected:
	// notation follows Hackbusch 
	// (Gr. GLS, p. 259, alg. 9.4.14a - 14f)
    TBlockVector<TFloat> r, a, q, p;
    TFloat               rho;

public:
	// constructor
	TCGSolver( TSolver *prec = NULL, TBlockMatrix *paA = NULL, 
               TBlockVector<TFloat> *paRHS = NULL, 
               TBlockVector<TFloat> *paX = NULL, 
               uint amaxiter = DEFAULT_MAX_ITERATION, 
               TFloat aaccur = DEFAULT_ACCURACY, 
               uint averb = 0 );

	// init. iteration
    void init ();
 
	// one iteration step
    int step ();
};

#endif  // __CGSOLVER_HH
