//
//  Project   : libnet
//  File      : convDiffDoFManager.hh
//  Author    : Sabine Gutsch
//  Purpose   : class for DoF manager for piecewise linear
//              elements for the convection-diffusion equation
//
// arch-tag: 2b689428-af8c-495c-8d0d-af0f438c0806
//

#ifndef __CONVDIFFDOFMANAGER_HH
#define __CONVDIFFDOFMANAGER_HH

#include "basisDoFManager.hh"

//
// class for DoF manager for piecewise linear
// elements for the convection-diffusion equation
//
class T2DConfDiffDoFManager : public TBasisDoFManager<2> 
{

public:
	// constructors	
    T2DConfDiffDoFManager ();
	// destructor
    ~T2DConfDiffDoFManager ();

	TBlockMatrix* buildStiffnessMatrix( TNet<2> *cNet, TNet<2> *fNet = NULL );
};

#endif  // __CONVDIFFDOFMANAGER_HH
