//
//  Project   : 
//  File      : defines.hh
//  Author    : Ronald Kriemann
//  Purpose   : common definitions
//
// arch-tag: 66f74a9a-441c-4e13-8354-5bb61d25abc2
//

#include <iostream>

using std::cout;
using std::cerr;
using std::endl;
using std::flush;
using std::ostream;
using std::ios;

#ifndef __DEFINES_HH
#define __DEFINES_HH

// common settings
#ifndef FALSE
#define FALSE 0
#endif

#ifndef false
#define false 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef true
#define true 1
#endif

// return-codes of the functions
#define SUCCESS	TRUE
#define ERROR	FALSE

// type declarations
typedef  unsigned char   uchar;
typedef  unsigned short  ushort;
typedef  char            byte;
typedef  unsigned char   ubyte;
typedef  unsigned int    uint;
typedef  unsigned long   ulong;
typedef  double          TFloat;

typedef  unsigned char   UINT8;
typedef  unsigned short  UINT16;
typedef  unsigned int    UINT32;

// functions
#define SGN( a ) (a >= 0 ? 1 : -1)
#define MIN(x,y) (x <  y ? x : y)
#define MAX(x,y) (x >  y ? x : y)

// some mathimatical constants
#ifndef PI
#  define PI  M_PI
#endif

#ifndef PI2
#  define PI2 (PI + PI)
#endif

#ifndef PI4
#  define PI4 (PI2 + PI2)
#endif

#ifndef SQRT2
#  ifdef M_SQRT2
#    define SQRT2 M_SQRT2
#  else
#    define SQRT2 1.41421356237309504880
#  endif
#endif

// for output of algorithm steps
#define  VERBOSE_STEP   1
#define  VERBOSE_TIME   2
#define  VERBOSE_RESULT 3

#endif			// __DEFINES_HH
