//
//  Project   : libnet
//  File      : optSquaredSmoother.hh
//  Author    : Sabine Gutsch 
//  Purpose   : smoother for a general system 
//              with parameters chosen to minimized residual
//
// arch-tag: 8df2725b-59f7-46e6-9cb3-26624c0c77ec
//

#ifndef __OPTSQUAREDSMOOTHER_HH
#define __OPTSQUAREDSMOOTHER_HH

#include "solver.hh"

class TOptSquaredSmoother : public TSolver {
    TFloat sigma, lambda;    // scaling parameter
    TFloat alpha, beta, gamma, delta, epsilon;
    TVectorBlock<TFloat> a0, a1, b0, b1, c, d0, d1, e0, e1, 
                         f0, f1, g, h, k0, k1;
    TBlockVector<TFloat> r;
 
public:
	// constructor
    TOptSquaredSmoother ( TBlockMatrix *paA = NULL, 
             TBlockVector<TFloat> *paRHS = NULL, 
             TBlockVector<TFloat> *paX = NULL, 
             uint amaxiter = DEFAULT_MAX_ITERATION,
             TFloat aaccur = DEFAULT_ACCURACY, 
             uint averb = 0 );

	// initialize residual
    void init();
    // one iteration step
    int step();
}; 

#endif  // __OPTSQUAREDSMOOTHER_HH
