//
//  Project   : libnet
//  File      : optSquaredSmoother2.hh
//  Author    : Sabine Gutsch 
//  Purpose   : smoother for a general system 
//              with parameters chosen to minimized residual
//
// arch-tag: 6ace9540-9153-4d5d-968b-8ff211a54e24
//

#ifndef __OPTSQUAREDSMOOTHER2_HH
#define __OPTSQUAREDSMOOTHER2_HH

#include "solver.hh"

class TOptSquaredSmoother2 : public TSolver {
    TFloat sigma, lambda;    // scaling parameter
    TBlockVector<TFloat> r, p, ap;
 
public:
	// constructor
    TOptSquaredSmoother2 ( TBlockMatrix *paA = NULL, 
             TBlockVector<TFloat> *paRHS = NULL, 
             TBlockVector<TFloat> *paX = NULL, 
             uint amaxiter = DEFAULT_MAX_ITERATION,
             TFloat aaccur = DEFAULT_ACCURACY, 
             uint averb = 0 );

	// initialize residual
    void init();
    // one iteration step
    int step();
}; 

#endif  // __OPTSQUAREDSMOOTHER2_HH
