//
//  Project     : libgraph
//  File        : rcm.hh
//  Author      : Ronald Kriemann
//  Purpose     : class for reversed Cuthill McKee algorithm
//  Date        : 28.10.1997
//
// arch-tag: a4f46c51-e95e-4992-9c2d-002532e168be
//

#ifndef __RCM_HH
#define __RCM_HH

#include "memory.hh"

#include "nodes.hh"
#include "basegraph.hh"
#include "blockinfo.hh"

//
//
//
class TRCM : public TMemory
{
protected:
	// doing breadth-first-search
	int bfs ( TGraph &graph, TMarkableNode &node );

	// find starting node
	TNode* findStartNode ( TGraph &graph );

public:
	// constructor
	TRCM ();

	// destructor
	~TRCM ();

	// do reversed Cuthill McKee
	void rcm ( TGraph &graph, TBlockInfo *blockinfo = NULL );
};

#endif  // __RCM_HH
