//
//  Project   : libnet
//  File      : stokesDoFManager.hh
//  Author    : Sabine Gutsch
//  Purpose   : DoFManager for linear conforming elements
//
// arch-tag: af80ade7-e697-40ef-befc-866bcfaa0fdf
//

#ifndef __STOKESDOFMANAGER_HH
#define __STOKESDOFMANAGER_HH

#include <string.h>

#include "basisDoFManager.hh"

// some names for our lists
#define U 0
#define P 1

//
// class for  
//
class T2DStokesDoFManager : public TBasisDoFManager<2> {

public:
	// constructors	
    T2DStokesDoFManager ();
	
	// destructor
    ~T2DStokesDoFManager ();

	// build stiffness matrix of coarse net, using the fine net  
	TBlockMatrix* buildStiffnessMatrix( TNet<2> *cNet, TNet<2> *fNet = NULL );
};

#endif  // __STOKESDOFMANAGER_HH
