//
//  Project   : Navier-Stokes
//  File      : TTerminal.cc
//  Author    : Ronald Kriemann
//  Purpose   : class providing terminal info
//
// arch-tag: 6b851e32-1c3e-4cd3-9887-e288740e5458
//

extern "C" {
#include <stdio.h>
#if defined(LINUX) || defined(DARWIN)
#include <sys/ioctl.h>
#endif

#ifdef SUNOS
#include <unistd.h>
#include <stropts.h>
#include <sys/termios.h>
#endif
}

#include "TTerminal.hh"

////////////////////////////////////////////////////
//
// constructor and destructor
//
TTerminal::TTerminal () {}

////////////////////////////////////////////////////
//
// methods for terminal status
//

uint
TTerminal::columns ()
{
    struct winsize  ws;

    if (ioctl( 0, TIOCGWINSZ, & ws ) != 0)
    {
        perror( "TTerminal::columns () : " );
        return 0;
    }// if

    return ws.ws_col;
}

uint
TTerminal::rows ()
{
    struct winsize  ws;

    if (ioctl( 0, TIOCGWINSZ, & ws ) != 0)
    {
        perror( "TTerminal::rows () : " );
        return 0;
    }// if

    return ws.ws_row;
}
