//
//  Project   : libnet
//  File      : T3DCubeDomain.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for representing a cubic domain in R^3
//
// arch-tag: 4e0a0365-597b-4666-af5e-cfd4e09e69fc
//

#include "T3DCubeDomain.hh"

////////////////////////////////////////////////////////////
//
// constructor and destructor
//

T3DCubeDomain::T3DCubeDomain ()
{
}

T3DCubeDomain::~T3DCubeDomain ()
{
}

///////////////////////////////////////////////////////////
//
// misc methods
//

//
// characteristic function of domain
//
bool
T3DCubeDomain::charFunc ( TVector<3> * pVector ) const
{
    if (pVector == NULL)
    {
        cout << "T3DCubeDomain::charFunc (...) : got NULL arg" << endl;
        return FALSE;
    }// if

    if (((*pVector)[X] >= vecMin[X]) && ((*pVector)[X] <= vecMax[X]) &&
        ((*pVector)[Y] >= vecMin[Y]) && ((*pVector)[Y] <= vecMax[Y]) &&
        ((*pVector)[Z] >= vecMin[Z]) && ((*pVector)[Z] <= vecMax[Z]))
        return TRUE;
    else
        return FALSE;
}
