//
//  Project   : libnet
//  File      : TBoundaryDesc.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: 1167ebc0-2960-4be1-a415-193bb2216265
//

#include "TCdrBoundaryDesc.hh"

//
// constructor
//
template< int N> 
TCdrBoundaryDesc<N>::TCdrBoundaryDesc ( int n ) 
{
    setNoOfTypes( n );
    aN=N;

    clearFlags();
}

//
// destructor
//
template< int N> 
TCdrBoundaryDesc<N>::~TCdrBoundaryDesc ()
{
}


// initialisation
template< int N> 
void
TCdrBoundaryDesc<N>::setNoOfTypes ( uint n )
{
    uint  oldSize = arrType.getSize();
    uint  i;
    
    arrType.setSize( n );
    arrFunc.setSize( n );

    clearFlags();
    
    for (i = oldSize; i < n; i++)
    {
       arrType[i]  = NO_TYPE;
       arrFunc[i] = NULL;
    }// for
}
   
//
// access func info
//
template< int N > 
TFunction<N> * TCdrBoundaryDesc<N>::getFunc ( uint i ) const
{
    if (i < getNoOfTypes())
        return arrFunc[i];
    else
    {
        cout << "TCdrBoundaryDesc::getFunc (" << i << ") : index too high" << endl;
        return NULL;
    }// else
}
template< int N> 
void
TCdrBoundaryDesc< N >::setFunc ( uint i, TFunction < N >* af )
{
    if (i < getNoOfTypes())
        arrFunc[i] = af;
    else
        cout << "TCdrBoundaryDesc::setFunc (" << i << ",int) : index too high" << endl;
}

template class TCdrBoundaryDesc<2>;
template class TCdrBoundaryDesc<3>;
template class TCdrBoundaryDesc<6>;
