//
//  Project   : libnet
//  File      : TBoundaryDesc.cc
//  Author    : Ronald Kriemann
//  Purpose   : class for representing info about boundaryvalues
//
// arch-tag: a6377b64-470d-45ab-bfbd-9d2538645871
//

#include "TPDEBoundaryDesc.hh"

//
// constructor
//
template< int N> 
TPDEBoundaryDesc<N>::TPDEBoundaryDesc ( int n ) 
{
 setNoOfTypes( n );
 aN = N;
}

//
// destructor
//
template< int N> 
TPDEBoundaryDesc<N>::~TPDEBoundaryDesc ()
{
}

//
// get N
//
template <int N>
int 
TPDEBoundaryDesc<N>::getN() const 
{ 
    return aN;
}

// initialisation
template< int N> 
void
TPDEBoundaryDesc<N>::setNoOfTypes ( uint n )
{
    uint oldSize = arrType.getSize();
    uint i;
    
    arrType.setSize( n );
    arrFunc.setSize( n );

    clearFlags();
    
    for (i = oldSize; i < n; i++)
    {
       arrType[i]  = NO_TYPE;
       arrFunc[i] = NULL;
    }// for
}
   
//
// access func info
//
template< int N > 
TFunction<N> * TPDEBoundaryDesc<N>::getFunc ( uint i ) const
{
    if (i < getNoOfTypes())
        return arrFunc[i];
    else
    {
        cout << "TPDEBoundaryDesc::getFunc (" << i << ") : index too high" << endl;
        return NULL;
    }// else
}
template< int N> 
void
TPDEBoundaryDesc< N >::setFunc ( uint i, TFunction < N >* af )
{
    if (i < getNoOfTypes())
        arrFunc[i] = af;
    else
        cout << "TPDEBoundaryDesc::setFunc (" << i 
             << ",int) : index too high" << endl;
}

template class TPDEBoundaryDesc<2>;
template class TPDEBoundaryDesc<3>;
template class TPDEBoundaryDesc<6>;
